/*----------------------------------------------------------------------*/
/* Definicion de todas las rutinas del Modulo de Definicion de Tipos.   */
/*----------------------------------------------------------------------*/
 

/* Funciones de represen.c */

extern void
nuevo_represent (char *);

extern nodo_nombre *
lista_rep_ambiente (char *dominio,char *codominio);

/* Funciones de symtable.c */

extern int loadSymbols(nodo_tad **,char *);

extern void freeSymbols(nodo_tad **);

extern int existsSymbol(nodo_tad *,char *,char *);

extern int existsName(nodo_nombre *nom,char *symb);

extern int existsSymbolParameter(nodo_tad *,char *,char *);

extern int existsGenerator(nodo_generadora *,char *);

extern int existsSelector(nodo_select *,char *);

extern int updateSymbols(nodo_tad **,nodo_tad *,char *);

extern void removeSymbolADT(nodo_tad **symt,char *tn);

/* funciones de anal_axs.c 
   -------------------------- */

extern
short analice_argum_generadora (FILE * fp, texpr mens_error, texpr str_axioma,
			      nodo_argum ** a, nodo_nombre * dom_generadora,
				nodo_expresion * expr_lado_izq);

extern
short analice_argum_select (FILE * fp, texpr mens_error, texpr str_axioma,
    nodo_argum ** a, nodo_dom * dom_select, nodo_expresion * expr_lado_izq);

extern
short analice_argum_tipo (FILE * fp, texpr mens_error, texpr str_axioma,
  cad20 nombre_tipo, nodo_expresion ** exp, nodo_expresion * expr_lado_izq);

extern
short analice_axiomas (texpr mens_error, nodo_igualdad ** cabeza_axs,
 		       cad50 nom_select, short *tipo_error);

extern
short analice_axiomas_m32(FILE *fp,char * mens_error, nodo_tad *ted);

extern short analice_expr_der (FILE * fp, texpr mens_error, texpr str_axioma,
		      nodo_expresion ** exp, nodo_expresion * expr_lado_izq,
			texpr tipo_izq);

extern
short analice_equal (FILE * fp, texpr mens_error, texpr str_axioma,
		     nodo_argum ** a, nodo_expresion * expr_lado_izq);

extern
short analice_expr_booleana (FILE * fp, texpr condicion, texpr mens_error,
		       nodo_expresion ** e, nodo_expresion * expr_lado_izq);

extern
short analice_expr_izq (FILE * fp, texpr mens_error, texpr str_axioma,
		   nodo_expresion ** e, texpr tipo_codom, cad50 nom_select);

extern
short analice_if (FILE * fp, texpr mens_error, texpr str_axioma, nodo_argum ** a,
		  nodo_expresion * expr_lado_izq, texpr tipo_izq);

extern
short determine_tipo_equal (FILE * fp, texpr mens_error,
			    nodo_expresion * expr_lado_izq, cad20 tipo_eq);

extern
short es_variable (cad20 nombre, nodo_expresion * exp, cad20 tipo);

extern
short es_variable_tipo (cad20 nombre, nodo_expresion * exp, cad20 tipo);


/* funciones de anal_sign.c
   --------------------------- */

extern
short analice_constructora (FILE * fp, texpr mens_error, nodo_generadora ** n);

extern
short analice_constructoras (FILE * fp, texpr mens_error);

extern
short analice_inicial (FILE * fp, texpr mens_error, nodo_generadora ** n);

extern
short analice_iniciales (FILE * fp, texpr mens_error);

extern
short analice_nombre (FILE * fp, texpr mens_error);

extern
short analice_prod_cjtos (char *,FILE * fp, texpr mens_error, 
			  nodo_nombre ** d, short tad_ed_valido, int *);

extern
short analice_selectora (FILE * fp, texpr mens_error, nodo_select ** n);

extern
short analice_selectoras (FILE * fp, texpr mens_error, int todo);

extern
short analizador_sintactico (texpr mens_error);

extern
void deme_token (FILE * fp);

extern
short es_cjto_conocido (texpr cjto, short tad_ed_valido,int *,int *);

extern
short es_identificador (texpr token);

extern
short es_error_esperaba (texpr cad1, texpr cad2, texpr mens_error);

extern
short es_separador (char c);


/* funciones de archivos.c
   -------------------------- */

extern
void escriba_arch_expresion (FILE * fp, nodo_expresion * e);

extern
int es_palabra_clave (cad12 nombre, texpr clav[MAX_CLAVES]);

extern
void reemplace_claves (nodo_expresion * e);

extern
short arch_modificado (cad20 nombre_arch);

extern
short busque_arch_tad (cad20 nom);

extern
void escriba_arch_generadoras (FILE * fp, nodo_generadora * cabeza);

extern
void escriba_arch_igualdades (FILE * fp, nodo_igualdad * cabeza);

extern
void escriba_arch_nombres (FILE * fp, nodo_nombre * cabeza, cad12 indent);

extern
void escriba_arch_selectoras (FILE * fp, nodo_select * cabeza);

extern
void escriba_arch_tad (cad20 nom, nodo_tad * p);

extern
void escriba_arch_tipo_clase (FILE * fp, nodo_expresion * e);

extern
int existe_archivo (texpr nombre, texpr dir);

extern
void lea_arch_generadoras (FILE * fp, nodo_generadora ** cabeza);

extern
void lea_arch_igualdades (FILE * fp, nodo_igualdad ** cabeza);

extern
void lea_arch_nombres (FILE * fp, nodo_nombre ** cabeza);

extern
void lea_arch_selectoras (FILE * fp, nodo_select ** cabeza);

extern
void lea_arch_tad (FILE * fp);

extern
void lea_arch_tipo_clase (FILE * fp, nodo_expresion * e);

extern
void nombre_archivo (cad20 nom, cad20 nom_arch);

/*extern
void nombre_archivoR (nodo_represent *nr, cad20 nom_arch);*/


/* funciones de axiomas.c
   ------------------------- */

extern
void arregle_dom_inicial (nodo_generadora * inic, nodo_argum * arg,
			  nodo_expresion * cab_ld_ax, char componente);

extern
short busque_li_axioma (texpr li_axioma, nodo_igualdad * cabeza, texpr ld_axioma);

extern
short cargue_axiomas (nodo_select * s);

extern
void editar_2w (char f_nombre[], char nombre_sel[]);

extern
short construya_axiomas (nodo_select * s, short restriccion, cad50 pred_restr,
			 cad12 nombre_tad_r, FILE *fp2);

extern
short construya_axs_formas_normales (nodo_tad *, nodo_select *, FILE *);

extern
void ed_arch_axiomas (FILE * fp, nodo_igualdad * cab_igs);

extern
void ed_arch_axiomas_ops (FILE * fp, nodo_select * cab_ops);

extern
short edite_axiomas (void);

extern
short edite_axiomas_selectora (nodo_tad * p, nodo_select * s);

extern
void edite_todos_axiomas_selectora (nodo_select * cab_ops);

extern
short es_parte_inicial (cad50 inic_simple, cad50 inic_comp);

extern
void escriba_arch_ed_ax_restr (FILE * fp, texpr ni, texpr nd, texpr li_axioma,
			       texpr cond_ld_axioma);

extern
void escriba_arch_ed_axiomas (FILE * fp, texpr li_axioma);

extern
short expr_isomorfas (nodo_expresion * expr1, nodo_expresion * expr2,
		      nodo_expresion * expr_der);

extern
void formatee_ld_axioma (nodo_expresion * expr, cad240 linea, int margen);

extern
void genere_ax_eq_pc (nodo_select * s, cad20 nom_tad1, cad20 nom_tad2);

extern
void genere_axiomas (FILE * fp, nodo_dom * d, texpr li_axioma,
		     char cont, nodo_igualdad * axs_viejos_select);

extern
void genere_axiomas_restr (FILE * fp, texpr ni, texpr nd, nodo_dom * d,
			   texpr li_axioma, texpr cond_ld_axioma,
			   cad50 pred_restr, cad12 nombre_tad_r,
			   char cont, nodo_igualdad * axs_viejos_select);

extern
void genere_axiomas_cruzados (nodo_select * s, nodo_generadora * cab,
			      nodo_generadora * cola);

extern
void genere_axiomas_proy_constr (nodo_select * s, nodo_generadora * cab,
				 nodo_generadora * cola);

extern
void genere_axiomas_proy_inic (nodo_tad * t, nodo_select * s, cad5 indice);

extern
void genere_axiomas_tipo (nodo_select * s, char componente);

extern
void genere_axs_tdi (FILE * fp, nodo_expresion * plant_li_ax, nodo_argum * arg,
		     nodo_generadora * cab_generad, char cont, char *adic);
/* VTP. 11/Jun/1997 Parametro adic agregado */

extern
void genere_eq_tipo (cad20 nom_tad, nodo_expresion * plant_select,
		     cad5 indice, nodo_argum ** arg_exp);

extern
void genere_exp_generadora (nodo_nombre * n, texpr exp, char *cont);

extern
void genere_proy_tipo (cad20 nom_tad, nodo_argum * arg, cad5 indice,
		       nodo_argum ** arg_exp);

extern
void ponga_generad_argum (FILE * fp, nodo_generadora * g, nodo_dom * d,
	     texpr li_axioma, char cont, nodo_igualdad * axs_viejos_select);

extern
void ponga_generad_argum_restr (FILE * fp, texpr ni, texpr nd,
				nodo_generadora * g, nodo_dom * d,
		    texpr li_axioma, texpr cond_ld_axioma, cad50 pred_restr,
	  cad12 nombre_tad_r, char cont, nodo_igualdad * axs_viejos_select);

extern
void reemplace_dom_inicial (cad50 nom_inic, nodo_expresion * cab_expr,
			    nodo_argum * cab_dom);

extern
void reemplace_inicial (cad50 nom_inic, cad50 nom_final, nodo_expresion * cabeza);

extern
void reemplace_var (cad20 var_vieja, cad20 var_nueva, nodo_expresion * exp);

extern
void renombre_var_inic (nodo_argum * arg, nodo_argum * cab_dom,
			nodo_expresion * cab_ld_ax, char componente);

extern
void transf_axioma_pc (nodo_select * s, nodo_igualdad ** ult_ax, nodo_argum * l_izq,
		     nodo_expresion * cab_li_ax, nodo_expresion * cab_ld_ax,
		       char componente, short nivel);


/*funciones de completacion.c
   ----------------------------- */

extern
void completacion (cad12 nom_tad_c);

extern
void informacion_tipo_completacion (nodo_tad * p, cad12 nom_tad_origen,
				    cad12 nom_elem_com);

extern
void genere_axs_compl (FILE * fp, nodo_select * s);

extern
void genere_inicial_completacion (cad12 nom_elem_com);

extern
int genere_selectoras_completacion (nodo_tad * tad_origen);


/* funciones de def_tipos.c
   --------------------------- */

extern
void copie_tad (cad12 nombre);

extern
void cree_nodo_tad (void);

extern
void instancie_parametro (cad12 nombre);

extern
void nuevo_tad (void);

extern
void suma_directa (cad12 nombre);


/* funciones de ed_tipos.c
   -------------------------- */

extern
int analice_cambios (void);

extern
int comparar_generadoras (nodo_generadora * g1, nodo_generadora * g2);

extern
int comparar_selectoras (nodo_select * s1, nodo_select * s2);

extern
void cree_arch_edicion_signatura (texpr nombre);

extern
void ed_arch_signatura (FILE * fp, nodo_tad * p);

extern
void ed_escriba_generadoras (FILE * fp, nodo_generadora * cabeza,
			     cad12 nombre_tad);

extern
void ed_escriba_igualdades (FILE * fp, nodo_igualdad * cabeza);

extern
void ed_escriba_info_tipo (FILE * fp, nodo_tad * p);

extern
void ed_escriba_nom_parametros (FILE * fp, nodo_tad * p);

extern
void ed_escriba_nombres (texpr linea, nodo_nombre * cabeza, texpr separador);

extern
void ed_escriba_selectoras (FILE * fp, nodo_select * cabeza);

extern
void edite_axs_existente (int num_menu_axs, nodo_select * cab_ops);

extern
int edite_igualdad (short pida_axiomas);

extern
void edite_sign_existente (void);

extern
void edite_tad_existente (void);

extern
void edite_tad_nuevo (cad20 nombre);

extern
void edite_todo_tad_existente (void);

extern
void esc_arch_edicion_signatura (nodo_tad * p);

extern
nodo_generadora *igual_generadora (nodo_tad * t, nodo_generadora * g,
				   int tipo);

extern
nodo_select *igual_selectora (nodo_tad * t, nodo_select * s);

extern
int iguales_parametros (nodo_tad * t1, nodo_tad * t2);

extern
void informacion_tipo_normal (nodo_tad * p);

extern
short pida_status (void);

extern
void reemplace_def (nodo_tad * p, nodo_tad * tad_ed);


/* funciones de expresiones.c
   ----------------------------- */

extern
void aisle_param (texpr exp, texpr exp_param);

extern
void construya_exp (nodo_expresion * cabeza, texpr exp, char *adic);
 /* VTP. 11/Jun/1997.  Parametro adic agregado */

extern
void construya_exp_tipo_clase (nodo_expresion * cabeza, texpr exp, texpr tipo,
			       texpr clase);
extern
void construya_param (texpr exp, nodo_expresion ** cabeza);

extern
void construya_subestruct (texpr exp, nodo_expresion ** cabeza);

extern
void parta_expresion (texpr exp, texpr exp_der, char simbolo);

extern
void predicado_ppal (texpr exp, texpr pred);

extern
void transf_estruct_iguald (nodo_igualdad * cabeza);

extern
void transf_iguald_estruct (texpr exp, nodo_igualdad ** cabeza);

extern
void liberar_igualdad (nodo_igualdad ** ig);

extern
void liberar_igualdades (nodo_igualdad ** ig);

extern
void liberar_dominios (nodo_dom ** d);

extern
void liberar_generadoras (nodo_generadora ** gen);

extern
void liberar_selectoras (nodo_select ** sel);

extern
void liberar_expresion (nodo_expresion ** expr);

extern
nodo_argum *crear_argumento (nodo_expresion * expr);

extern
nodo_argum *copia_argum (nodo_argum* inarg);
/* VTP. Feb/1998 */

extern
nodo_expresion *copia_expresion (nodo_expresion * inexp);
/* VTP. Feb/1998 */



/* funciones de extension.c
   --------------------------- */

extern
short construya_axs_selec_sum_direc (nodo_tad * tad, nodo_select * s,
                                     char *adic, FILE *fp2);
        /* VTP. 11/Jun/1997.  Ultimos parametro agregados. */

extern
void extension (cad12 nom_tad_e);

extern
void genere_axs_extens (FILE * fp, nodo_tad * tad, nodo_select * s, char *adic);
        /* VTP. 11/Jun/1997.  Ultimo parametro agregado. */
        
extern
void genere_constructoras_sum_direc (nodo_tad * p, nodo_tad * q);

extern
void genere_iniciales_sum_direc (nodo_tad * p, nodo_tad * q);

extern
void genere_param_sum_direc (nodo_tad * p, nodo_tad * q);

extern
int genere_selectoras_extension (nodo_tad * tad_origen1, nodo_tad * tad_origen2);

extern
void informacion_tipo_extension (nodo_tad * p, cad12 nom_tad_origen1,
				 cad12 nom_tad_origen2);


/* funciones de interf_tipos.c
   ------------------------------ */

extern
short desea_corregir_edicion (int tipo_error, texpr mens_error);

extern
short desea_def_igualdad (void);

extern
void edite_stat_existente (void);

extern
void encuentre_min (cad20 lineas[50], int pos_inic, int pos_fin, int *min);

extern
void lea_nombre_nuevo_tad (cad12 nombre);

extern
void lista_parametros_tad (cad20 lineas[50], short *num_params);

extern
nodo_nombre *lista_selectoras (nodo_select * cab_op);

extern
nodo_nombre *lista_tads_ambiente (void);

extern
void ordene_alfab (cad20 lineas[50], int pos_inic, int pos_fin);

extern
void pida_elem_completacion (cad12 nom_tad_c, cad12 nom_tad_padre,
			     cad12 nom_elem_com);

extern
nodo_nombre *pida_nodo_param (nodo_nombre * cab_param);

extern
void pida_predicado_restr (cad12 nom_tad_padre, cad12 nom_pred_r);

extern
nodo_tad *pida_tad_ambiente (texpr mensaje);


/* funciones de lib_listas.c
   ---------------------------- */

extern
void asignar_nombre_sel (nodo_select * sel_nuevo, nodo_select * sel_viejo,
			 texpr tad_nuevo, texpr indice, char *);

extern
void asignar_nombre_gen (nodo_generadora * gen_nuevo,
			 nodo_generadora * gen_viejo,
			 texpr tad_nuevo, texpr indice);

extern
void asigne_nombre (texpr nombre_final, texpr nombre_viejo,
		    texpr nom_cambio, texpr nuevo_nom, cad12 indice);

extern
void busque_argum_var_tdi (nodo_argum * cab, cad20 nom_tad, nodo_argum ** arg_tdi);

extern
nodo_nombre *busque_nodo_nom (nodo_nombre * cab_lista, texpr nombre);

extern
void construya_dom_generad (nodo_generadora * inic, nodo_argum ** cab_dom,
			    char *cont);

extern
void construya_dom_select (nodo_select * s, nodo_argum ** cab_dom, char *cont);

extern
void copie_lado_der (nodo_expresion * cabeza, nodo_expresion ** nueva_cabeza,
		     nodo_tad * p, cad12 indice);

extern
void copie_ld_argum (nodo_argum * cabeza, nodo_argum ** nueva_cabeza,
		     nodo_tad * p, cad12 indice);

extern
void copie_lista_argum (nodo_argum * cabeza, nodo_argum ** nueva_cabeza,
			cad50 nom, nodo_tad * t, char *);

extern
void copie_lista_argum_apunt (nodo_argum * cabeza, nodo_argum ** nueva_cabeza,
			      nodo_argum * ap, nodo_argum ** nap);

extern
void copie_lista_componentes (nodo_componente * cabeza,
			      nodo_componente ** nueva_cabeza,
			      nodo_componente ** ult_comp);

extern
void copie_lista_expresion (nodo_expresion * cabeza,
			    nodo_expresion ** nueva_cabeza,
			    cad50 nom, nodo_tad * t, char *);
                            /* VTP. 3/Jun/1997 Agregado ultimo parametro */

extern
void revisar_lista_expresion (nodo_expresion * cabeza, nodo_tad * t,
			      char nom[]);

extern
void copie_lista_expresion_apunt (nodo_expresion * cabeza,
				  nodo_expresion ** nueva_cabeza,
				  nodo_argum * ap, nodo_argum ** nap);

extern
void copie_lista_generadoras (nodo_generadora * cabeza,
			      nodo_generadora ** nueva_cabeza,
			      nodo_generadora ** ult_generad,
			      texpr nom, texpr nuevo_nom, cad12 indice);

extern
void copie_lista_igualdades (nodo_igualdad * cabeza, nodo_igualdad ** nueva_cabeza,
			     cad50 nom, cad50 nuevo_nom, cad12 indice,
			     nodo_tad * t,char *adic_nom);

extern
void revisar_lista_igualdades (nodo_igualdad * cabeza, nodo_tad * t,
			       char nom[]);

extern
void copie_lista_nombres (nodo_nombre * cabeza, nodo_nombre ** nueva_cabeza,
			  nodo_nombre ** ult_nom,
			  texpr nom, texpr nuevo_nom, cad12 indice);

extern
void copie_lista_selectoras (nodo_select * cabeza,
			     nodo_select ** nueva_cabeza,
			     nodo_select ** ult_select,
			     texpr nom, texpr nuevo_nom, cad12 indice,
			     nodo_tad * t, char *);

extern
void genere_plantilla_generadora (nodo_generadora * g, cad20 nom_codom,
			     nodo_expresion ** plant_construct, char *cont);

extern
void genere_plantilla_selectora (nodo_select * s, nodo_expresion ** plant_select,
				 char *cont);

extern
int longitud_lista_argum (nodo_argum * cabeza);

extern
void subindique_axs (nodo_igualdad * cabeza, cad12 indice);

extern
void subindique_expr (nodo_expresion * cabeza, cad12 indice);

extern
void suprima_param_tad (nodo_tad * p, cad50 nom_param);

extern
nodo_nombre *lista_tipos (nodo_tad * t);

extern
int lista_tipos_recursivo(nodo_tad *,nodo_nombre**,char *);

int                                    
related_types_list(nodo_tad *,nodo_nombre**,char *);

int                                      
add_type_recTypeList(char *,nodo_nombre **,char *);

int
types_from_axioms(nodo_igualdad *,nodo_nombre**,char *);

int
types_from_expression(nodo_expresion *, nodo_nombre**, char *);

extern
void liberar_nombres (nodo_nombre ** l);

extern
int existe_nombre (nodo_nombre * l, cad20 nombre);

extern
void insertar_nombre_ord (nodo_nombre ** l, cad20 nombre);

extern
void adicionar_nombre (nodo_nombre ** l, cad20 nombre);

extern
void insertar_expresion (nodo_argum ** l, nodo_expresion * expr);


/* funciones de man_tipos.c
   --------------------------- */

extern
void manejar_tipos(void);

extern
void borre_tad (nodo_tad * p);

extern
void cargar_tad (char *nombre_tad);

extern
void cargue_tad (void);

extern
void elimine_primitivos (nodo_nombre ** lis);

extern
void cargue_tads_primitivos (void);

extern
nodo_tad *crear_tad (void);

extern
void edite_tad_amb (void);

extern
nodo_tad *existe_tad (cad12 nom);

extern
nodo_tad *existe_tad_amb (cad12 nom);

extern
void cambiar_nombre_sel (nodo_tad * p, cad12 nuevo_nom);

extern
void genere_copia_tad (nodo_tad * p, cad12 viejo_nom, nodo_tad * np, cad12 nuevo_nom);

extern
void cambiar_clase_expresion (nodo_expresion * e, texpr nom_viejo,
			      texpr nom_nuevo);

extern
void cambiar_nombre (nodo_tad * t, texpr nom_viejo, texpr nom_nuevo);

extern
void imprima_tad (nodo_tad * p);

extern
void liberar_tad (nodo_tad ** t);

extern
void salvar_backup (char dir[], char nombre[], char ext[]);

extern
void salve_tad (nodo_tad * t);

extern
void salve_todo_tad (void);

extern
int tipo_primitivo (cad20 nombre);


/* funciones de princ_def.c
   --------------------------- */

extern
void aumente_variables (nodo_tupla * s, int num_var);

extern
void ayuda_tuplas_complet_comp (FILE * fp, nodo_select * s);

extern
short cubre_generad (nodo_tupla * cab_s, texpr mens_error, nodo_generadora * cabeza, cad50 posic_param, cad50 max_posic);

extern
short cubre_generadoras (nodo_tupla * s, texpr mens_error, cad50 posic_param,
			 cad50 max_posic);

extern
void elimine_prim_comp (nodo_tupla * ns, cad50 posic_param, cad50 max_posic);

extern
short es_completo (nodo_tupla * s, texpr mens_error, cad50 posic_param,
		   cad50 max_posic);

extern
short es_definicion_completa (nodo_igualdad * axiomas, texpr mens_error);

extern
short es_vacio (nodo_tupla * s);

extern
void expanda_argum (nodo_tupla * s, int *num_var);

extern
void insertar_tupla (nodo_tupla * s, nodo_tupla ** ns, nodo_tupla ** ult_tupla);

extern
void normalice (nodo_igualdad * axiomas, nodo_tupla ** s);

extern
short tuplas_prim_comp_var_completo (nodo_tupla * s, texpr mens_error,
				     cad50 posic_param, cad50 max_posic);


/* funciones de prod_implic.c
   ----------------------------- */

extern
void adic_igualdad (nodo_tad * p, nodo_tad * q);

extern
void genere_param_pc (nodo_tad * p, nodo_tad * q);

extern
void informacion_tipo_prod (nodo_tad * p, cad12 nom_tad1, cad12 nom_tad2);

extern
void adic_proy_implic (cad20 nom_codom, cad5 indice, nodo_expresion * plant_inic,
		       nodo_argum * arg, nodo_select ** cab_select);

extern
void adic_proyecciones_implic (nodo_tad * p, nodo_tad * q);

extern
void convierta_constrs_selects (nodo_tad * p, nodo_select ** cab_lista,
				nodo_select ** ult_lista, cad5 indice);

extern
void genere_axiomas_proy_implic (nodo_select * s, cad5 indice,
			     nodo_expresion * plant_inic, nodo_argum * arg);

extern
void genere_axs_select_implic (nodo_select * s, cad5 indice, cad12 nom_tad1,
			       cad12 nom_tad2);

extern
void genere_inicial_pc_implic (nodo_tad * p, nodo_tad * q);

extern
void genere_selectoras_pc_implic (nodo_tad * p, nodo_tad * q);

extern
void prod_cart_implicito (cad12 nom_pc);

extern
void proyecte_args_tdi (nodo_expresion * l_axioma, cad12 nom_tad1, cad5 indice);


/* funciones de proy_tad.c
   -------------------------- */

extern
void adic_select_eq (nodo_tad * p, nodo_select ** select_eq);

extern
nodo_select *busque_selectora (texpr nombre, nodo_select * cab_ops);

extern
short es_constructora_tipo (texpr token, cad20 tipo);

extern
short es_constructora_tipo_dom (cad20 nombre, cad20 tipo, nodo_nombre ** dominio);

extern
short es_generadora (cad20 nombre, nodo_generadora * cabeza);

extern
short es_generadora_algun_tipo (cad20 nombre, cad20 tipo);

extern
short es_generadora_con_codom_tipo (cad20 nombre, nodo_generadora * cabeza,
				    nodo_nombre ** dominio);

extern
short es_inicial_tipo (texpr token, cad20 tipo);

extern
short es_inicial_tipo_dom (cad20 nombre, cad20 tipo, nodo_nombre ** dominio);

extern
short es_parametro (cad20 nombre, nodo_nombre * cabeza);

extern
short es_selectora (cad20 nombre, nodo_select * cabeza);

extern
short es_selectora_algun_tipo (cad20 nombre, cad20 tipo);

extern
short es_selectora_con_codom_tipo (cad20 nombre, cad20 tipo,
				 nodo_select * cabeza, nodo_dom ** dominio);

extern
short es_selectora_dom_codom (cad20 nombre, nodo_select * cabeza,
			      nodo_dom ** tipo_dom, cad20 tipo_codom);

extern
short es_selectora_tipo_dom (cad20 nombre, cad20 tipo, nodo_dom ** dominio);

extern
short num_parametros (nodo_tad * t);

extern
short tiene_argums_induccion (nodo_select * s);

extern
short tiene_igualdad_definida (nodo_tad * p);


/* funciones de restriccion.c
   ----------------------------- */

extern
nodo_tad *tad_restriccion (nodo_tad * tad_p);

extern
void genere_selectora_restr (nodo_tad * tad_padre, cad12 nom_pred_r);

extern
void informacion_tipo_restr (nodo_tad * p, cad12 nom_tad_origen, cad12 nom_pred_r);

extern
void restriccion (cad12 nom_tad_r);


/* funciones de variacion.c
   --------------------------- */

extern
int genere_iniciales_variacion(nodo_tad *,nodo_tad *, nodo_tad *);

extern
short genere_select_conversion (nodo_tad * t1, nodo_tad * t2,
				nodo_select ** cab_select, FILE *fp2);

extern
int genere_selectoras_variacion (nodo_tad * tad_origen1, nodo_tad * tad_origen2);

extern
void informacion_tipo_variacion (nodo_tad * p, cad12 nom_tad_origen1,
				 cad12 nom_tad_origen2);

extern
void variacion (cad12 nom_tad_v);


/* funciones de interf.c
   ------------------------ */

extern
int admon_menu (ptr_menu m);

extern
void admon_menu_scroll (ptr_menu m, nodo_nombre * lis, texpr comando);

extern
void adic_opcion (ptr_menu m, opcion o);

extern
void borrar_menu (ptr_menu m);

extern
opcion crear_opcion (char nombre[]);

extern
ptr_menu crear_menu (void);

extern
void desp_presentacion (void);

extern
void escriba_cadena (cad50 cadena, int n);

extern
void escriba_dir (cad20 dir, cad20 ext);

extern
void escriba_mensaje (int num_mensaje);

extern
void escriba_mensaje_dinam (texpr mensaje);

extern
short es_prefijo (cad20 comando, cad50 cad_opcion);

extern
void formatear_linea (texpr lin1, texpr lin2);

/* extern
void formatear_nombre (texpr lin1, texpr lin2); VTP. 3/Jun/1997
es funcion dependiente del sistema operativo */ 

extern
void iniciar_menus (void);

extern
void iniciar_mensajes (void);

extern
void iniciar_claves (void);

extern
void iniciar_editor_direct (cad20 nombre);

extern
void lea_cadena (cad12 cad_resp);

extern
char lea_caracter (void);

extern
void lea_nombre (cad50 mensaje, cad12 nombre);

extern
void llenar_menu (ptr_menu m, nodo_nombre * lis);

extern
void nombre_autor (texpr nombre);

extern
void opcion_inactiva (void);

extern
int opcion_valida (ptr_menu m, texpr comando);

extern
void pase_mayusculas (texpr linea);

extern
void pintar_menu (ptr_menu m);

extern
void enviar_menu (ptr_menu m);

extern
void enviar_dir (cad20 dir, cad20 ext);

extern
void enviar_mensaje (int num_mensaje);

extern
void pedir_nombre (cad20 mensaje, cad12 nombre);

extern
void llamar_al_editor (int num_archs, trio_edicion edicion[3], cad50 p_emacs);

extern
void enviar_mensaje_dinamico (texpr mensaje);

extern
void esc_nom_tad_actual (void);

extern
void esc_nom_represent_actual (void);


/*** VTP. 13/Ene/97 ***/

extern
int copia_archivo (char *fuente, char *destino);
/* Copia el archivo con nombre fuente en destino.  Portable */

extern
int touch (char *nomarc);
/* Actualiza la fecha y hora del archivo nomarc.  Portable */
