
/**
 * ManTa (3.1) C Code Generator
 * Version: 3.1b4 - 1999
 * Author: Vladimir Tamara
 * See details at http://wwwisc.uniandes.edu.co/~manta
 **/

#include <stdio.h>
#include <assert.h>
#include <stdlib.h>
#include <string.h>

#include "apimanta.h"
#include "os_dep.h"


#define maxInFiles 100

/****************
  PROTOTYPES
 ****************/

/* Loads a type written in a text file (not in environment)  */
nodo_tad *loadTextType(char *name);


/*****************
    MAIN   
 *****************/

int main(int argc,char *argv[])
{

  nodo_tad *et;
  int rc;
  char configFile[200];
  char inFile[maxInFiles][100];
  int numInFiles=0;
  int i;
  int bytecode=0;
  int error=0;
  FILE *fp;
  texpr merr;
  
  printf(" ManTa C Code Generator  v 3.1b4\n");
  printf(" Universidad de los Andes.  \n"
         " Software Construction Group.   1999\n"
         " See http://wwwisc.uniandes.edu.co/~manta\n\n");


  strcpy(configFile,"manta.ini\0");
  
  for (error=0,i=1;!error && i<argc;i++)
    {
      if (argv[i][0]=='-')
	{
	  switch (argv[i][1]) 
	    {
	    case 'b': 
	      bytecode=1;
	      break;
	    case 'd': 
	      if (i+1<argc)
		{ 
		  if (chdir(argv[i+1])!=0) {
		    printf("Could'nt change to directory %s\n",argv[i+1]);
		    error=1;
		  }
		  i++;
		}
	      else
		{ error=1; }
	      break;
	    case 'i': 
	      if (i+1<argc)
		{ 
		  strcpy(configFile,argv[i+1]); 
		  transArch(configFile);  
		  i++;
		}
	      else
		{ error=1; }
	      break;
	    default:
	      error=1;
	      break;
	    }
	}
      else /* It must be an input file */
	{
	  if (numInFiles>maxInFiles)
	    { 
	      printf("Can't translate more than %i files\n",maxInFiles);
	      rc=3;
	      goto exit;
	    }
	  strcpy(inFile[numInFiles],argv[i]);
	  transArch(inFile[numInFiles]);
	  numInFiles++;
	}
    }
  if (numInFiles==0)
    { error=1; }
  
  if (error)
    {
      printf("Syntax is: \n"
             " m2c [-d <dir>] [-b] [-i <confFile>] <inFile>"
	     " [<inFile> <inFile> ...] \n"
	     "<dir> is the working directory\n"
             "<confFile> is the configuration file (by default manta.ini)\n"
	     "<workDir> is the working directory\n"
             "<inFile> is a text file with an ADT to generate\n"
	     "The -b option indicates that each input file is a bytecode\n");
      return 1;
    }

  if (iniMantaAPI(configFile)<0)
    {
      printf("Initialization Failed (sure you have config file %s ?)\n",
	     configFile);
      return 1;
    }

  for (i=0;i<numInFiles;i++)
    {
      if (bytecode)
	{
	  fp=fopen(inFile[i],"rt");
	  if (fp==NULL)
	    {  
	      printf("File not found %s\n",inFile[i]);
	      rc=2;
	      goto exit;
	    }
	  merr[0]='\0';
	  et=NULL;
	  if (cargaTipo(fp,&et,merr)!=0)
	    {
	      printf("Can't load type %s\n%s",inFile[i],merr); 
	      rc=2;
	      fclose(fp);
	      goto exit;
	    }
	  fclose(fp);
	}
      else if ((et=loadTextType(inFile[i]))==NULL)
	{
	  rc=2;
	  goto exit;
	}
      if ((rc=generaCProt(et,CP_TODO))!=0)
	{
	  printf("Problems generating C code\n");
	  goto exit;
	}
      if (et!=NULL)
	{ 
	  elimNodoTipo(&et);
	  et=NULL;
	}
  
      printf("  Succesfull generation of %s\n\n",inFile[i]);
    }

 exit:
  if (et!=NULL)
    { elimNodoTipo(&et); }
  finMantaAPI();
  return rc;
}


/**
 * Loads a type written in a text file (not in environment)
 * @param name is the file name
 **/
nodo_tad *loadTextType(char *name)
{

  FILE *f;
  texpr msg;
  nodo_tad *tad=NULL;
  assert(name!=NULL);

  transArch(name);
  f=fopen(name,"rb");
  if (f==NULL)
    {
      printf("File not found. \n");
      return NULL;
    }
  msg[0]='\0';
  if (cargaTipoTexto(f,&tad,msg))
    {
      printf("Error loading file. Message:\n");
      printf("%s\n",msg);
    }
  fclose(f);
  return tad;
}

