
/* INTER31.C  (Antiguo INTERF.C)				      */
/* Arhivo con algunas funciones del manejo de interfaces de ManTa 3.1 */

#include <string.h>
#include <ctype.h>
#include "definic.h"
#include "apimanta.h"

/* Variables Globales del proyecto */
char CadErrorAssert[200];

texpr nombre_usuario="";
int  flag_emacs=0;         /* permite saber si opera la interfaz emacs */
cad20            direct[255];     /* Directorios usados por manta   */
ptr_menu menus_manta[MAX_MENUS]; /*-- Menus del programa          --*/
texpr mensajes[MAX_MENSAJES];
int total_mensajes=0; /* VTP. 30/Abr/1997 Numero de Mensajes */
texpr claves[MAX_CLAVES];
texpr claves_manta[MAX_CLAVES];

nodo_tad		*tad=NULL;		/* Apunt. a la lista de TADs 	  */
nodo_tad		*ult_tad=NULL;       /* Apunt. al ult. TAD de la lista */
nodo_tad		*tad_actual=NULL;    /* Apunt. al TAD procesado actual */
nodo_tad		*tad_ed=NULL;        /* Apunt. al TAD editado actual   */

cad20            editor[5];      /* Parametros del editor          */
cad20            direct[255];     /* Directorios usados por manta   */
int 		fila=0,columna=0;
texpr		token="";
int		num_ed=0;		/* Num. de la linea siendo editada*/
short		desea_ayuda_tuplas_comp=1;  /* 1, Si el usuario desea */
                                   /* ayuda, 0, Sino.  */
cad50		posic_param_incompl="";
					/* Posicion en notac. del argum. */
					/* no completo dentro del arbol  */
					/* de la expresion.		 */
nodo_nombre	*parametros=NULL;	/* Apunt. a la lista de parametros*/
					/* se desea desplegar en el menu  */
					/* de parametros 	          */
nodo_tad	*represent=NULL;	  /* Apunt. a la lista de represents*/
nodo_tad	*ult_represent=NULL;   /* Apunt. a la ult. represent de  */
					  /* la lista */
nodo_demost *unproved=NULL;     /*-- Lista de conjeturas no probadas. --*/
nodo_demost *ult_unproved=NULL; /*-- Ultima no probada.               --*/
nodo_demost *proved=NULL;       /*-- Lista de conjeturas probadas.    --*/
nodo_demost *ult_proved=NULL;   /*-- Ultima probada.                  --*/
nodo_igualdad *especiales=NULL; /*-- Son reglas que se aplican con    --*/
                                 /*-- politicas especiales.            --*/
ptr_menu menus_manta[MAX_MENUS]; /*-- Menus del programa          --*/


/* A este codigo fuente se le han aplicado estas tecnicas preventivas:*/
/* 1. assert al comienzo de toda funcion para verificar precondiciones */
/* 2. HayMem despues de cada malloc para verificar que se asigne memoria
      y para inicializar cada zona de memoria reservada en 0 */
/* 3. Los apuntadores liberados han sido dejados apuntando a NULL */
/* 4. Todo apuntador local a funciones no inicializado ha sido inicializado
      en NULL */
/* 5. Despues de cada fopen se agrego la funcion FileOpen */
/* v-tamara 7/May/1997 */

/**************************************************************************
* void formatear_linea(texpr lin1, texpr lin2)                            *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   Quitar los puntos del principio y fin de la linea lin1,    *
*              y dejar la respuesta en lin2.                              *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* AUTOR: Cesar Munoz                                     FECHA: 28-Nov-91 *
**************************************************************************/

void formatear_linea(texpr lin1, texpr lin2)
{/*----------------------------------------------------------------------*/
	 int prim,ult; /* Primer y ultimo caracter imprimible de lin */
	 int j;

	 assert(lin1!=NULL && lin2!=NULL && strlen(lin1)<MAX_TEXPR
			  && strlen(lin2)<MAX_TEXPR); /* VTP. 23/Abr/1997 */

	 for (prim=0,ult = strlen(lin1);(prim < ult) && (lin1[prim] != '.');prim++);
	 for (;(ult > prim) && (lin1[ult] != '.');ult--);
	 for (j=0,prim++;prim < ult; j++,prim++) {
		  if (lin1[prim] == '\\') {
				switch (lin1[++prim]) {
					 case 'n' :
						  lin2[j] = '\n';
						  break;
					 case 't' :
						  lin2[j] = '\t';
						  break;
					 default :
						  lin2[j] = lin1[prim];
						  break;
				}
		  }
		  else
				lin2[j] = lin1[prim];
	 }
	 lin2[j]='\0';
 /*----------------------------------------------------------------------*/}

/**************************************************************************
* void iniciar_editor_direct(cad20 nombre)	    			  *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   Iniciar el arreglo editor, y direc                         *
*              archivo D_MANTA/D_MESAGE/nombre.                           *
* PRE!:  El archivo nombre contiene la informacion de un editor, con el   *
*        siguiente formato :                                              *
* 1. linea : Nombre del editor                                            *
* 2. linea : Opcion para ir a una linea                                   *
* 3. linea : Opcion de editar read-only                                   *
* POST!: { editor[0] = nombre del editor,                                 *
*          editor[1] = opcion para ir a una linea                         *
*          editor[2] = opcion para editar read-only }                     *
* OJO : Si el nombre no corresponde a un archivo, se carga el editor vi   *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* AUTOR: Cesar Munoz                                     FECHA: 28-Nov-91 *
**************************************************************************/

void iniciar_editor_direct(cad20 nombre)
{/*----------------------------------------------------------------------*/
	 FILE   *fp;
	 texpr  linea;
	 int    i;
	 cad5   flag;

	 assert(nombre!=NULL && strlen(nombre)<20); /* VTP. 23/Abr/1997 */

	 for (i=0;i!=5;i++)
		  strcpy(editor[i],"\0");
	 for (i=0;i!=20;i++)
		  strcpy(direct[i],"\0");

	 fp = fopen(nombre,"r");
	 if (fp != NULL) {
		fgets(linea,sizeof(texpr),fp);  /* toma el flag_emacs que dice si
					 emacs hace la interfaz o no */
		formatear_linea(linea,flag);
		if (!strcmp(flag,"1"))
			flag_emacs = 1;
		else
			flag_emacs = 0;
		fgets(linea,sizeof(texpr),fp);
		for( i = 0; i < 3; i++) {
			formatear_linea(linea,editor[i]);
			fgets(linea,sizeof(texpr),fp);
		}
		for( i = 0; !feof(fp); i++) {
			formatear_linea(linea,direct[i]);
			fgets(linea,sizeof(texpr),fp);
		}
	 }
	 else {
		escriba_cadena("No pudo abrir archivo de configuracion",2);
	 }
/*----------------------------------------------------------------------*/}

/**************************************************************************
* void iniciar_mensajes(void)                                             *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   Iniciar el arreglo de mensajes con el contenido del        *
*              archivo de mensajes.                                       *
* PRE!:  { Nombre es un archivo de mesajes con este formato :             *
*    nnnn   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx                        *
*   Donde nnnn es el numero del mensaje y xxxxxxx es el mensaje           *
*    or  nombre es espacio or nombre no corresponde a ningun archivo      *
* POST!: { Si nombre es correcto carga el archivo de mensajes, si es      *
*          vacio o incorrecto, carga el archivo mesages.msg               *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* AUTOR: Cesar Munoz                                     FECHA: 28-Nov-91 *
**************************************************************************/

void iniciar_mensajes(void)
{/*----------------------------------------------------------------------*/
     FILE   *fp;
     texpr  archivo;
     texpr  linea;
     int    i,fin;

     for (i=0;i<MAX_MENSAJES;i++)
              strcpy(mensajes[i],"\0");
     sprintf(archivo,"%s/%s",direct[0],direct[11]);
     fp = fopen(archivo,"r");
     if (fp == NULL)        
       {
	 sprintf(linea,"Can't open messages file: %s\n",archivo);
	 escriba_cadena(linea,2);
	 exit(1);
     }
     total_mensajes=0;
     do {
              fin = fscanf(fp,"%5d",&i);
              assert(i<MAX_MENSAJES);
              if (fin != EOF)
                            fgets(linea,sizeof(texpr),fp);
              formatear_linea(linea,mensajes[i]);
              total_mensajes=i+1>total_mensajes?i+1:total_mensajes; /* VTP. 30/Abr/1997 */
     } while (!feof(fp));
/*----------------------------------------------------------------------*/}

/**************************************************************************
* void iniciar_claves(void)                                               *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   Iniciar el arreglo de palabras claves con el contenido del *
*              archivo de claves.                                         *
* PRE!:  { Nombre es un archivo de mesajes con este formato :             *
*    nnnn   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx                        *
*   Donde nnnn es el numero del mensaje y xxxxxxx es el mensaje           *
*    or  nombre es espacio or nombre no corresponde a ningun archivo      *
* POST!: { Si nombre es correcto carga el archivo de mensajes, si es      *
*          vacio o incorrecto, carga el archivo claves.msg                *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* AUTOR: Cesar Munoz                                     FECHA: 28-Nov-91 *
**************************************************************************/

void iniciar_claves(void)
{/*----------------------------------------------------------------------*/

	 FILE   *fp;
	 texpr  archivo;
	 texpr  linea;
	 int    i,fin;


	 for (i=0;i<MAX_CLAVES;i++) {
		strcpy(claves[i],"\0");
		strcpy(claves_manta[i],"\0");
	 }
	 sprintf(archivo,"%s/%s",direct[0],direct[9]);
	 fp = fopen(archivo,"r");
	 if (fp == NULL) {
		  escriba_cadena("Problemas con el archivo de claves",2);
		  exit(1);
	 }
	 do {
		fin = fscanf(fp,"%5d",&i);
		if (fin != EOF) {
			fgets(linea,sizeof(texpr),fp);
			formatear_linea(linea,claves[i]);
		}
	 } while (!feof(fp));

	 sprintf(archivo,"%s/claves_m.msg",direct[0]);
	 /* VTP. 30/Abr/1997 Decia claves_manta.msg */
	 fp = fopen(archivo,"r");
	 if (fp == NULL)  {
		escriba_cadena("Problemas con el archivo de claves de Manta",2);
		return;
	 }
	 do {
		fin = fscanf(fp,"%5d",&i);
		if (fin != EOF) {
			fgets(linea,sizeof(texpr),fp);
			formatear_linea(linea,claves_manta[i]);
		}
	 } while (!feof(fp));
/*----------------------------------------------------------------------*/}

/**************************************************************************
* void pase_mayusculas(texpr linea)					  *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   Pasa a mayusculas todas las letras en la cadena <linea>.   *
* PARAMETROS: texpr  linea          String a ser convertido a mayusculas. *
* PRE!:  { linea = "a1 .. an" }.                                          *
* POST!: { linea = "mayuscula(a1) .. mayuscula(an)" }.                    *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* AUTOR: Carolina Ruiz Carrizosa                         FECHA: 25-Ene-90 *
**************************************************************************/

void pase_mayusculas(texpr linea)
{/*----------------------------------------------------------------------*/
  int i;
  assert(linea!=NULL && strlen(linea)<MAX_TEXPR); /* VTP. 23/Abr/1997 */
	 for (i=0; linea[i] != '\0' ; i++)
		linea[i] = (char)toupper(linea[i])
	 ;
/*----------------------------------------------------------------------*/}

/**************************************************************************
* short es_prefijo(cad20 comando,cad50 cad_opcion)  			  *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   Verificar si <comando> es prefijo de <cad_opcion>.         *
* PARAMETROS: cad20  comando                                              *
*             cad50  cad_opcion                                           *
* RESULTADO:  short  1, si <comando> es prefijo de <cad_op>. 0, sino.     *
* PRE!:  { comando = "a1 .. ak" , cad_opcion = "b1 .. bn" }.              *
* POST!: { es_prefijo = 1, si a1 = b1, ... ,ak = bk. 0, sino }.           *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* AUTOR: Carolina Ruiz Carrizosa                         FECHA: 25-Ene-90 *
**************************************************************************/

short es_prefijo(cad20 comando,cad50 cad_opcion)
{/*----------------------------------------------------------------------*/
  int i;

  assert(comando!=NULL && strlen(comando)<=20 && cad_opcion!=NULL &&
         strlen(cad_opcion)<=50); /* VTP. 23/Abr/1997 */

	 for (i=0; (comando[i] != '\0') && (cad_opcion[i] != 0) &&
				  (tolower(comando[i]) == tolower(cad_opcion[i])) ; i++)
	 ;
	 if (comando[i] == '\0')
		return(1);
	 else
		return(0)
	 ;
/*----------------------------------------------------------------------*/}



/**************************************************************************
void escriba_cadena(char *cad, int n)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
  PROPOSITO:   Reemplaza funcion de la antigua interfaz.
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
  AUTOR: Vladimir Tamara Patino                        FECHA: 17-Jun-1998
**************************************************************************/
void escriba_cadena(char *cad, int n)
{/*----------------------------------------------------------------------*/
  int i;
  assert(cad!=NULL);
  if (cad[0]=='\0')
    {
      return;
    }
  printf(cad);
  for (i=0;i<n;i++)
    {
      printf("\n");
    }
/*----------------------------------------------------------------------*/}

/**************************************************************************
* void escriba_mensaje(int num_mensaje)	                                  *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   Reemplaza funcion de la antigua interfaz.
*              Muestra un mensaje asociado al codigo num_mensaje
**************************************************************************/

void escriba_mensaje(int num_mensaje)
{/*----------------------------------------------------------------------*/
   assert(num_mensaje>=0 && num_mensaje<total_mensajes); /* VTP. 23/Abr/1997 */
   escriba_cadena(mensajes[num_mensaje],0);
/*----------------------------------------------------------------------*/}

/**************************************************************************
* void escriba_mensaje_dinam(int num_mensaje)	                          *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   Escribe un mensaje dinamico (creado en ejecucion) en la    *
*              pantalla                                                   *
*                                                                         *
**************************************************************************/
void escriba_mensaje_dinam(texpr mensaje)
{/*----------------------------------------------------------------------*/
    assert(mensaje!=NULL && strlen(mensaje)<MAX_TEXPR); /* VTP. 23/Abr/1997 */
    escriba_cadena(mensaje,0);
/*----------------------------------------------------------------------*/}




/**********   POR ELIMINAR ***********/

void admon_menu_scroll(ptr_menu m, nodo_nombre *lis, texpr comando)
{/*--------------------------------------------------------------------*/
 assert(m!=NULL);
 assert(lis!=NULL);
 assert(comando!=NULL);
/*--------------------------------------------------------------------*/}

int admon_menu(ptr_menu m)
{/*--------------------------------------------------------------------*/
  assert(m!=NULL);
    return 0;
/*--------------------------------------------------------------------*/}

void  escriba_dir( cad20 dir, cad20 ext)
{/*----------------------------------------------------------------------*/
  assert(dir!=NULL);
  assert(ext!=NULL);

/*----------------------------------------------------------------------*/}

void lea_nombre(cad50 mensaje,cad12 nombre)
{/*----------------------------------------------------------------------*/
  assert(mensaje!=NULL);
  assert(nombre!=NULL);
/*----------------------------------------------------------------------*/}


void llamar_al_editor(int num_archs, trio_edicion edicion[MAX_EDICION],
		      cad50 p_emacs)
{/*----------------------------------------------------------------------*/
  assert(p_emacs!=NULL);
  assert(num_archs>=0);
  assert(edicion!=NULL);
/*----------------------------------------------------------------------*/}

char lea_caracter()
{/*----------------------------------------------------------------------*/
    return '\0';
/*----------------------------------------------------------------------*/}

void lea_cadena(cad12 cad_resp)
{/*----------------------------------------------------------------------*/
  assert(cad_resp!=NULL);
/*----------------------------------------------------------------------*/}

void esc_nom_tad_actual()
{
}



