/* Manta31 Benchmark */
/* By Vladimir Tamara P. */
/* 1998 */

#include <stdio.h>
#include <assert.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>

#define MAXL 2000
#define BENCH_VERSION "1.1"

float acum=0;   /* Time required */
int num_proved=0;   
int num_unproved=0;

/* Count time, proved and unproved conjectures */
void stat(void);

int main(int argc, char *argv[])
{

  int ner,nl,totl;
  int ultp;
  FILE *con,*tmp;
  char li[MAXL];
  time_t start, end;
  char arc[200];

  printf("Manta31 Benchmark 1.0\n");
  printf("---------------------\n\n");

  tmp=fopen("manbench.log","wt");
  if (tmp==NULL)
    {
      printf("Can't write file manbench.log\n");
      return -1;
    }
  fclose(tmp);

  if (argc==1)
    { strcpy(arc,"nqthm92/nqthm92.con"); }
  else
    { strcpy(arc,argv[1]); }
  con=fopen(arc,"rt");
  if (con==NULL)
    {
      printf("The conjectures file %s couldn't be opened\n",arc);
      return -1;
    }
  totl=0; /* Total de conjeturas */
  while (!feof(con))
    {
      fgets(li,MAXL,con);
      totl++;
    }
  fclose(con);
  printf("Conjectures to test: %i\n",totl);


  con=fopen(arc,"rt");
  if (con==NULL)
    {
      printf("The conjectures file %s couldn't be opened\n",arc);
      return -1;
    }
  nl=0;   /* Total de conjeturas */
  ultp=-1; /* Ultimo porcentaje impreso */

  start = time(NULL);
  while (!feof(con))
    {
      fgets(li,MAXL,con);
      if (100*nl/totl!=ultp)
	{ 
	  printf("%i %%\n",100*nl/totl);
	  ultp=100*nl/totl;
	}

      tmp=fopen("nq92tmp.con","wt");
      if (tmp==NULL)
	{
	  printf("Can't write in file nq92tmp.con\n");
	  fclose(con);
	  return -1;
	}
      fputs(li,tmp);
      fclose(tmp);

      system("./nq92 nq92tmp.con >>manbench.log");

      nl++;
    }
  fclose(con);
  printf("100 %%\n");
  end = time(NULL);

  printf("\n\n"
	 "ManTa kernel version        : 3.1b4\n");
  printf("ManTa Benchmark version     : %s\n",BENCH_VERSION);
  printf("Conjectures tested          : %i\n",nl);
  stat();
  printf("Conjectures proved          : %i\n",num_proved);
  printf("Conjectures not proved      : %i\n",num_unproved);
  ner=nl-(num_proved+num_unproved);
  printf("Conjectures with problems   : %i\n",ner);
  printf("Time required in proofs     : %f sec.\n",acum);
  printf("Time required in benchmark  : %li sec.\n",end-start);
  printf("Average time per Conjecture : %f\n",acum/(nl-num_proved));
  printf("Proof capacity              : %f %%\n",(float)100*num_proved/nl);
  return 0;
}



/* Count time, proved and unproved conjectures */
void stat()
{
  FILE *log;
  char li[MAXL];

  log=fopen("manbench.log","rt");

  while (!feof(log))
    {
      fgets(li,MAXL,log);
      if (strncmp(li,"Time:",5)==0)
	{
	  if (li[strlen(li)-1]=='\n')
	    { li[strlen(li)-1]='\0'; }
	  acum+=atof(li+6);
	}
      else if (strncmp(li,"Proved:",7)==0)
	{
	  if (li[strlen(li)-1]=='\n')
	    { li[strlen(li)-1]='\0'; }
	  num_proved+=atoi(li+8);
	}
      else if (strncmp(li,"Unproved:",9)==0)
	{
	  if (li[strlen(li)-1]=='\n')
	    { li[strlen(li)-1]='\0'; }
	  num_unproved+=atoi(li+10);
	}
    }
  fclose(log);
}

